import {
  GdsElement
} from "./chunk.6X2WDWO3.js";
import {
  gdsCustomElement,
  html
} from "./chunk.MLXMQIEV.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/form/summary/summary.ts
import { msg, str } from "@lit/localize";
import { css } from "lit";
import { when } from "lit/directives/when.js";
var GdsFormSummary = class extends GdsElement {
  connectedCallback() {
    super.connectedCallback();
    this.form = this.closest("form") || void 0;
    if (this.form) {
      this.formObserver = new MutationObserver(() => {
        this.requestUpdate();
      });
      this.formObserver.observe(this.form, { attributes: true, subtree: true });
    }
  }
  disconnectedCallback() {
    var _a;
    super.disconnectedCallback();
    (_a = this.formObserver) == null ? void 0 : _a.disconnect();
  }
  render() {
    var _a;
    const formControlElements = Array.from(
      ((_a = this.form) == null ? void 0 : _a.elements) || []
    );
    const errors = formControlElements.filter((e) => e.invalid);
    return when(
      errors.length > 0,
      () => html`<gds-card level="3" border="4xs/negative" border-radius="2xs" padding="m" color="error-text">
          <gds-flex gap="s" level=="3" color="negative">
            <gds-container>
              <gds-icon-triangle-exclamation></gds-icon-triangle-exclamation>
            </gds-container>
            <gds-container >
            ${msg(
        str`There are ${errors.length} errors to correct before you can continue:`
      )}
            <ul>
              ${errors.map(
        (el) => html`<li><a href @click=${(e) => {
          e.preventDefault();
          el.focus();
        }}>${el.label}</li>`
      )}
            </ul>
          </gds-container>
        <gds-flex>
      </gds-card>`
    );
  }
};
GdsFormSummary.styles = css`
    :host {
      font-weight: 500;
    }
    ul {
      list-style-type: none;
      margin: 1rem 0 0;
      padding: 0;
    }
    li {
      margin: 0.5rem 0;
    }
    a {
      color: var(--gds-sys-color-primary-text);
      font-weight: 500;
    }
  `;
GdsFormSummary = __decorateClass([
  gdsCustomElement("gds-form-summary")
], GdsFormSummary);

export {
  GdsFormSummary
};
