import {
  defaultStyles
} from "./chunk.UEJZWDMS.js";
import {
  observeLightDOM
} from "./chunk.WM7HBMMV.js";
import {
  tokens
} from "./chunk.47ASHWGJ.js";
import {
  GdsElement
} from "./chunk.6X2WDWO3.js";
import {
  gdsCustomElement
} from "./chunk.MLXMQIEV.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/rich-text/rich-text.styles.ts
import { css } from "lit";
var styles = css`
  :host {
    font-size: var(--gds-text-size-body-m);
    line-height: var(--gds-text-line-height-body-m);
    --default-border: 1px solid
      color-mix(in srgb, currentColor, transparent 80%);
    letter-spacing: 0.0125rem;
  }

  :host > :first-child {
    margin-top: 0;
  }

  /*
  * typography
  * -----------------------------------------------------------
  */
  h1,
  h2,
  h3,
  h4,
  h5,
  h6 {
    margin-top: 0.6lh;
    margin-bottom: 0.3lh;
  }

  p {
    margin-bottom: 1lh;
    max-width: 80ch;
  }

  blockquote {
    margin: unset;
    margin-block: 2lh;
    border-left: 0.2rem solid currentColor;
    padding-left: 2ch;
    max-width: 40ch;
  }

  s {
    text-decoration: underline;
    text-decoration-skip-ink: none;
    text-underline-offset: -0.22lh;
  }

  mark {
    color: currentColor;
    background-color: color-mix(in srgb, currentColor, transparent 80%);
  }

  /*
  * lists
  * -----------------------------------------------------------
  */
  ul,
  ol,
  li {
    margin: 0 0 0 1ch;
    padding: 0 0 0.3lh 0;
  }
  li:last-child {
    padding: 0;
  }

  ul li::marker {
    content: '– ';
  }

  /*
  * figure
  * -----------------------------------------------------------
  */
  figure {
    margin: 0;
    padding: 0;
    & img {
      display: block;
    }
  }
  figcaption {
    font-size: smaller;
    margin-block-start: 0.4lh;
  }

  /*
  * table
  * -----------------------------------------------------------
  */
  table {
    border-collapse: separate;
    border-spacing: 0;
    width: 100%;
    border: var(--default-border);
    border-radius: var(--gds-space-s);
  }
  th {
    font-weight: var(--gds-text-weight-book);
    text-align: left;
    border-bottom: var(--default-border);
    border-left: transparent;
    border-right: transparent;
    color: var(--gds-color-l3-content-secondary);
  }

  th:not(:last-child) {
    border-right: var(--default-border);
  }

  th,
  td {
    padding: 0.3lh 2ch;
  }
  td:not(:last-child) {
    border-right: var(--default-border);
  }
  tr:nth-child(even) td {
    background: color-mix(in srgb, currentColor, transparent 95%);
  }

  /*
  * Details
  * -----------------------------------------------------------
  */
  details {
    border-top: solid var(--gds-space-4xs) var(--gds-color-l3-border-tertiary);
    font-size: var(--gds-text-size-body-m);
    line-height: var(--gds-text-line-height-body-m);
    color: var(--gds-color-l2-content-secondary);
  }

  summary {
    font-weight: var(--gds-text-weight-regular);
    list-style: none;
    padding: 0.4lh 0.2ch;
    font-size: var(--gds-text-size-body-l);
    line-height: var(--gds-text-line-height-body-l);
    color: var(--gds-color-l2-content-primary);
    display: flex;
    justify-content: space-between;
    align-items: center;
    cursor: pointer;
    user-select: none;
    outline-offset: var(--gds-space-2xs);
    outline-color: currentColor;

    &:focus-visible {
      border-radius: var(--gds-space-2xs);
    }
  }

  summary::after {
    content: '+';
    display: flex;
    align-items: center;
    justify-content: center;
    width: 24px;
    height: 24px;
    font-weight: var(--gds-text-weight-regular);
    font-size: var(--gds-text-size-body-l);
  }

  details[open] summary::after {
    content: '-';
  }

  details[open] {
    margin-bottom: 1lh;
  }

  details[open] summary {
    border-bottom: var(--gds-space-4xs) solid
      var(--gds-color-l3-border-tertiary);
  }
`;

// libs/core/src/components/rich-text/rich-text.ts
var GdsRichText = class extends GdsElement {
  /**
   * Forwards the selector to the corresponding function on the inner shadowRoot.
   */
  querySelectorAll(selector) {
    if (!this.shadowRoot)
      return new NodeList();
    return this.shadowRoot.querySelectorAll(selector);
  }
  /**
   * Forwards the selector to the corresponding function on the inner shadowRoot.
   */
  querySelector(selector) {
    if (!this.shadowRoot)
      return null;
    return this.shadowRoot.querySelector(selector);
  }
  /**
   * Forwards innerHTML from the inner shadowRoot.
   */
  get innerHTML() {
    var _a;
    return ((_a = this.shadowRoot) == null ? void 0 : _a.innerHTML) || "";
  }
  set innerHTML(value) {
    if (!this.shadowRoot)
      return;
    this.shadowRoot.innerHTML = value;
  }
  connectedCallback() {
    super.connectedCallback();
    this._captureDOM();
  }
  _captureDOM() {
    if (!this.shadowRoot || this.childNodes.length === 0)
      return;
    this.shadowRoot.replaceChildren(...Array.from(this.childNodes));
  }
};
GdsRichText.styles = [tokens, defaultStyles, styles];
__decorateClass([
  observeLightDOM()
], GdsRichText.prototype, "_captureDOM", 1);
GdsRichText = __decorateClass([
  gdsCustomElement("gds-rich-text")
], GdsRichText);

export {
  GdsRichText
};
