import {
  tokens
} from "./chunk.47ASHWGJ.js";
import {
  GdsElement
} from "./chunk.6X2WDWO3.js";
import {
  gdsCustomElement
} from "./chunk.MLXMQIEV.js";
import {
  __decorateClass,
  __privateAdd,
  __privateGet
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/link/link.ts
import { unsafeCSS } from "lit";
import { property } from "lit/decorators.js";
import { classMap } from "lit/directives/class-map.js";
import { ifDefined } from "lit/directives/if-defined.js";
import { html as staticHtml } from "lit/static-html.js";

// libs/core/src/components/link/link.styles.ts
import { css } from "lit";
var style = css`
  @layer core, link;

  @layer core {
    :host {
      display: inline-block;
    }
  }

  @layer link {
    a {
      display: flex;
      align-items: center;
      gap: 1ch;
      text-decoration: underline;
      text-underline-offset: 0.2lh;
      color: currentColor;
      outline-offset: 4px;
      outline-color: currentColor;
      font-weight: var(--gds-text-weight-book);

      &:hover {
        text-decoration: none;
      }

      &.secondary {
        text-decoration: none;

        &:hover {
          text-decoration: underline;
        }
      }
    }
  }
`;
var link_styles_default = style;

// libs/core/src/components/link/link.ts
var _defaultRel, defaultRel_get;
var GdsLink = class extends GdsElement {
  constructor() {
    super();
    __privateAdd(this, _defaultRel);
    this.href = "";
    this.variant = "default";
  }
  render() {
    const CLASSES = {
      secondary: this.variant === "secondary"
    };
    return staticHtml`
      <a
        href=${ifDefined(this.href)}
        target=${ifDefined(this.target)}
        rel=${ifDefined(this.rel || __privateGet(this, _defaultRel, defaultRel_get))}
        download=${ifDefined(this.download)}
        class=${classMap(CLASSES)}
      >
        <slot name="lead"></slot>
        <slot></slot>
        <slot name="trail"></slot>
      </a>
    `;
  }
};
_defaultRel = new WeakSet();
defaultRel_get = function() {
  return this.target === "_blank" ? "noreferrer noopener" : void 0;
};
GdsLink.styles = [tokens, unsafeCSS(link_styles_default)];
GdsLink.shadowRootOptions = {
  mode: "open",
  delegatesFocus: true
};
__decorateClass([
  property()
], GdsLink.prototype, "href", 2);
__decorateClass([
  property()
], GdsLink.prototype, "target", 2);
__decorateClass([
  property()
], GdsLink.prototype, "rel", 2);
__decorateClass([
  property()
], GdsLink.prototype, "download", 2);
__decorateClass([
  property()
], GdsLink.prototype, "variant", 2);
GdsLink = __decorateClass([
  gdsCustomElement("gds-link")
], GdsLink);

export {
  GdsLink
};
