import { GdsContainer } from '../container';
/**
 *  A container for content representing a single entity. e.g. a contact, article, or task.
 *
 * `gds-card` inherits all properties from `gds-container`, but comes with some predefined defaults
 * and a shortcut property for specifiying different card variants.
 *
 * @element gds-card
 * @status beta
 *
 */
export declare class GdsCard extends GdsContainer {
    static styles: (import("lit").CSSResult | import("lit").CSSResult[])[];
    /**
     * Controls the box-shadow property.
     *
     * These are the available values you can use to define shadow size
     *
     * `xs`, `s`, `m`, `l`, `xl`
     *
     */
    shadow?: string;
    /**
     * Shortcut for setting the border, background and text color of the card to the specified color variant, such as 'primary', 'secondary', 'tertiary', etc.
     *
     * You can find all available variants in the L2 section of the [Color System documentation page](./?path=/docs/style-colors--docs)
     *
     * Supports Style Expression syntax for setting the value responsively.
     *
     */
    variant: string;
    constructor();
    render(): any;
}
