import { GdsFormControlElement } from '../form/form-control';
import type { GdsFilterChip } from './filter-chip';
import './filter-chip';
/**
 * @element gds-filter-chips
 * @status stable
 *
 * @slot - The filter chips to display
 *
 * @fires change - When a chip is clicked
 */
export declare class GdsFilterChips<ValueT = any> extends GdsFormControlElement<ValueT | ValueT[]> {
    #private;
    static styles: import("lit").CSSResult[];
    /**
     * The value of the currently selected chip or chips. This will be an array
     * if multi-select is enabled.
     */
    value?: ValueT | ValueT[];
    /**
     * Whether multiple chips can be selected at once.
     * @attr multiple
     */
    multiple: boolean;
    /**
     * The accessible label for the control
     * @attr label
     */
    label: string;
    /**
     * Returns the chips in the control
     * @readonly
     */
    get chips(): GdsFilterChip<any>[];
    /**
     * Whether the chips should collapse into a single row when space is limited
     * @attr row-collapse
     */
    rowCollapse: boolean;
    private _collapsed;
    private _elSlot;
    render(): any;
    protected _getValidityAnchor(): HTMLElement;
    private _handleResize;
    private _updateSelectedFromValue;
}
