import { GdsFlex } from '../flex';
/**
 * @element gds-mask
 */
export declare class GdsMask extends GdsFlex {
    static styles: (import("lit").CSSResult | import("lit").CSSResult[])[];
    'mask-image'?: string;
    'mask-size': string;
    'mask-repeat': string;
    'mask-position': string;
    'background-color'?: string;
    /**
     * Controls the backdrop-filter property of the container.
     * When you want to apply a backdrop blur filter to the container you can use this property.
     *
     * ```html
     * <gds-mask backdrop-filter="20px"></gds-mask>
     * ```
     *
     * The above example will apply a backdrop blur filter of `20px`.
     *
     *  The filter also support breakpoint syntax like this:
     *
     * ```html
     * <gds-mask backdrop-filter="s{20px} m{40px} l{60px}"></gds-mask>
     * ```
     *
     * The above example will apply the filter style of `20px` for `small` devices, `40px` for `medium` devices, and `60px` for large devices.
     */
    'backdrop-filter'?: string;
    constructor();
    render(): import("lit-html").TemplateResult;
}
