import { GdsElement } from '../../gds-element';
/**
 * `gds-rich-text` can be used to wrap generic HTML content and apply typography styles.
 *
 * The wrapped content will get captured and transferred to the inner shadowRoot of the `gds-rich-text` element.
 *
 * @element gds-rich-text
 * @status beta
 *
 */
export declare class GdsRichText extends GdsElement {
    static styles: (import("lit").CSSResult | import("lit").CSSResult[])[];
    /**
     * Forwards the selector to the corresponding function on the inner shadowRoot.
     */
    querySelectorAll(selector: string): NodeList;
    /**
     * Forwards the selector to the corresponding function on the inner shadowRoot.
     */
    querySelector(selector: string): Element | null;
    /**
     * Forwards innerHTML from the inner shadowRoot.
     */
    get innerHTML(): string;
    set innerHTML(value: string);
    connectedCallback(): void;
    private _captureDOM;
}
