import { CSSResult, ReactiveController } from 'lit';
import { GdsElement } from '../gds-element';
export declare class DynamicStylesController implements ReactiveController {
    #private;
    host: GdsElement;
    constructor(host: GdsElement);
    hostConnected(): void;
    /**
     * Injects CSS into the host element's shadow root. The key is used to
     * identify the styles and can be used to update the styles later. If
     * you need to clear style for a particular key, you can call `inject`
     * with an empty string as the `styles` parameter.
     *
     * @param key - A unique key to identify the styles.
     * @param styles - The CSSResult to inject.
     */
    inject(key: string, styles: CSSResult): void;
    /**
     * Clears all styles of the component, including any initial styles.
     */
    clearAll(): void;
}
export declare function supportsConstructedStylesheets(): boolean;
